<template>
<div class="wrapper wrapper-content animated fadeInRight">
    <div class="row">
        <div class="col-lg-12">
            <div class="ibox float-e-margins">
                <div class="ibox-title">
                    <h5>List Of Employee</h5>
                    <div class="ibox-tools">
                        <a class="btn btn-primary btn-xs" @click="modal_show()">
                            Add Employee
                        </a>
                        <a @click="load_employee()">
                            <i class="fa fa-refresh"></i>
                        </a>
                    </div>
                </div>
                <!-- /.ibox-titel -->
                
                <div class="ibox-content">
                    <!-- Search and filter form -->
                    <div class="row">
                        <div class="col-lg-12">
                            <div class="pull-left form-inline">
                                <label>Show 
                                    <input type="number" v-model="show_row" class="form-control input-sm" 
                                            style="width:60px;" min="1" max="1000">
                                </label>


                                <label>&nbsp;&nbsp;Limit
                                    <input type="number" v-model="limit" class="form-control input-sm" 
                                            style="width:70px;" min="1" max="1000">
                                </label>
                            </div>

                            <div class="pull-right form-inline">
                                <label>Search:
                                    <input v-model="search_key" class="form-control input-sm">
                                </label>&nbsp;
                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                
                    <div class="row" v-if="employees.total">
                        <div class="col-lg-12">
                            <div>
                                <div>
                                    <p class="pull-left" style="margin-top: 7px;">
                                        Showing  {{ employees.from }} to  {{ employees.to }}  of  {{ employees.total }} entries.
                                    </p>
                                </div>
                                <div class="table_pagination">
                                    <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                                
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : !employees.prev_page_url }" 
                                            @click=" gen_uri( employees.prev_page_url )"
                                        >
                                            <span>Prev</span>
                                        </a>  
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : !employees.first_page_url }" 
                                            @click=" gen_uri( employees.first_page_url )">
                                            <span>First</span>
                                        </a>
                                        <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : !employees.last_page_url }" 
                                            @click=" gen_uri(employees.last_page_url)">
                                        <span>Last</span>
                                        </a>
                                        <a class="btn btn-white btn-sm" 
                                            v-bind:class="{ disabled : !employees.next_page_url }" 
                                            @click=" gen_uri( employees.next_page_url )"
                                        >
                                        <span>Next</span>
                                        </a>
                                    </div>
                                </div>        
                            </div>
                        </div>
                    </div>
                    <!-- /.row -->

                    <!-- Table -->
                    <div class="project-list table-responsive">
                        <table class="table table-stripped">
                            <thead>
                                <tr>
                                    <th class="text-center">#</th>
                                    <th>Full Name</th>
                                    <th>Job Title</th>
                                    <th>Hired Date</th>
                                    <th>&nbsp;</th>
                                </tr>
                            </thead>
                            <tbody v-if="loading">
                                <tr>
                                    <td colspan="8">
                                        <spinner></spinner>
                                    </td>
                                </tr>
                            </tbody>
                            <tbody  v-else-if="employees.data.length">
                                <employee-table v-for="(employee, row) in employees.data" 
                                            :key="employee.id" 
                                            :employee="employee" 
                                            v-on:delete="employee_delete"
                                            :row="row"
                                >
                                </employee-table>
                            </tbody>
                            <tbody v-else>
                                <tr>
                                    <td colspan="8" class="text-center">
                                        No Result!
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <!-- /.table-responsive -->
                </div>
                <!-- /.ibox-content -->
            </div>
        </div>
    </div>

    <employee-modal v-on:save="employee_store" v-bind:modal="modal">
    </employee-modal>
</div>

<!-- /.wrapper wrapper-content animated fadeInRight -->
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'

export default {
    components: {
        'employee-modal': Modal,
        'employee-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            employees: [],
            modal: { 
                pause_save: false,
                errors: '',
                data: {}
            },
        }
    },
    methods: {
        load_employee () {
            this.loading = true
            let uri = this.uri
            axios.get(uri).then((response,reject) => {
                this.employees = response.data.employees
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'employee',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }
            this.uri = appService.crud.generate_url( query ) 
            this.$router.push( this.uri )
        },
        modal_show() {
            this.modal.errors = ''
            this.modal.data = {
                civil_status: '',
            }
            $('#employee_modal').modal('show');
        },
        employee_store( data ) {
            this.modal.pause_save = true
            appService.crud.store( '/employee', data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#employee_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.load_employee()
                }
            })
            this.modal.pause_save = false
        },
        employee_delete( id ) {
            appService.crud.delete( `/employee/${id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.load_employee()
                }
            })
        },
    },  
    watch: {
        '$route' (to, from) {
            this.load_employee()
        },
        show_row: function () {
            this.loading = true
            this.gen_uri()
        },
        limit: function () {
            this.loading = true
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
                this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_employee()
    }
}
</script>